note
	description: "Summary description for {RESIDENT_STUDENT}."
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	NON_RESIDENT_STUDENT

create
	make

feature -- Attributes
	name: STRING
	courses: LINKED_LIST[COURSE]
	discount_rate: REAL

feature -- Constructor
	make (n: STRING)
			-- Initialize a student with name 'n'.
		do
			name := n
			create {LINKED_LIST[COURSE]} courses.make
		end

feature -- Commands
	set_dr (r: REAL)
			-- Set premium rate.
		do
			discount_rate := r
		end

	register (c: COURSE)
		do
			courses.extend (c)
		end

feature -- Queries
	tuition: REAL
		local
			base: REAL
		do
			base := 0.0
			across
				courses as c
			loop
				base := base + c.item.fee
			end
			Result := base * discount_rate
		end
end
